READELF(1)

NAME
readelf - display information about ELF objects

SYNOPSIS
readelf [-a | --all] [-c | --archive-index] [-d | --dynamic] [-e | --headers] [-g | --section-groups] [-h | --file-header] [-l | --program-headers] [-n | --notes] [-p section | --string-dump=section] [-r | --relocs] [-t | --section-details] [-x section | --hex-dump=section] [-v | --version] [ -w[afilmoprsFLR] | --debug-dump[=long-option-name,...]] [-A | --arch-specific] [-D | --use-dynamic] [-H | --help] [-I | --histogram] [-N | --full-section-name] [-S | --sections | --section-headers] [-V | --version-info] [-W | --wide] file...

DESCRIPTION
The readelf utility displays information about ELF objects and ar(1) archives.

The readelf utility recognizes the following options:

-a | --all
    Turn on the following flags: -d, -h, -I, -l, -r, -s, -A, -S and -V.

-c | --archive-index
    Print the archive symbol table for archives.

-d | --dynamic
    Print the contents of the SHT_DYNAMIC sections in the ELF object.

-e | --headers
    Print all program, file and section headers in the ELF object.

-g | --section-groups
    Print the contents of the section groups in the ELF object.

-h | --file-header
    Print the file header of the ELF object.

-l | --program-headers
    Print the content of the program header table for the object.

-n | --notes
    Print the contents of PT_NOTE segments or SHT_NOTE sections present in the ELF object.

-p section | --string-dump=section
    Print the contents of the specified section as printable strings. The argument section should be the name of a section or a numeric section index.

-r | --relocs
    Print relocation information.

-s | --syms | --symbols
    Print symbol tables.

-t | --section-details
    Print additional information about sections, such as the flags fields in section headers.

-v | --version
    Prints a version identifier for readelf and exits.

-w[afilmoprsFLR] |
    --debug-dump[=long-option-name,...] Display DWARF information. The -w option is used with the short options in the following table; the --debug-dump option is used with a comma-separated list of the corresponding long option names:
    Short Option | Long Option | Description
    a | abbrev | Show abbreviation information.
    f | frames | Show frame information, displaying frame instructions.
    i | info | Show debugging information entries.
    l | rawline | Show line information in raw form.
    m | macro | Show macro information.
    o | loc | Show location list information.
    p | pubnames | Show global names.
    r | aranges|ranges | Show address range information.
    s | str | Show the debug string table.
    F | frames-interp | Show frame information, displaying register rules.
    L | decodedline | Show line information in decoded form.
    R | Ranges | Show range lists.

    If no sub-options are specified, the default is to show information corresponding to the a, f, i, l, o, p, r, s and R short options.

-x section | --hex-dump=section
    Display the contents of the specified section in hexadecimal. The argument section should be the name of a section or a numeric section index.

-A | --arch-specific
    This option is accepted but is currently unimplemented.

-D | --use-dynamic
    Print the symbol table specified by the DT_SYMTAB entry in the “.dynamic” section.

-H | --help
    Print a help message.

-I | --histogram
    Print information on bucket list lengths for sections of type SHT_HASH and SHT_GNU_HASH.

-N | --full-section-name
    This option is accepted but is currently unimplemented.

-S | --sections | --section-headers
    Print information in the section headers for each ELF object.

-V | --version-info
    Print symbol versioning information.

-W | --wide
    Print information about ELF structures using one long line per structure. If this option is not specified, readelf will list information in the headers of 64 bit ELF objects on two separate lines.

EXIT STATUS

SEE ALSO
nm(1), addr2line(1), elfcopy(1),

AUTHORS
The readelf utility was written by Kai Wang <kaiwang27@users.sourceforge.net>.